linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: "Paul E. McKenney" <paulmck@linux.ibm.com>
To: linux-kernel@vger.kernel.org, linux-arch@vger.kernel.org,
	mingo@kernel.org
Cc: stern@rowland.harvard.edu, andrea.parri@amarulasolutions.com,
	will@kernel.org, peterz@infradead.org, boqun.feng@gmail.com,
	npiggin@gmail.com, dhowells@redhat.com, j.alglave@ucl.ac.uk,
	luc.maranget@inria.fr, akiyks@gmail.com,
	"Paul E. McKenney" <paulmck@linux.ibm.com>
Subject: [PATCH RFC memory-model 20/31] tools/memory-model: Implement --hw support for checkghlitmus.sh
Date: Thu,  1 Aug 2019 15:20:45 -0700	[thread overview]
Message-ID: <20190801222056.12144-20-paulmck@linux.ibm.com> (raw)
In-Reply-To: <20190801222026.GA11315@linux.ibm.com>

This commits enables the "--hw" argument for the checkghlitmus.sh script,
causing it to convert any applicable C-language litmus tests to the
specified flavor of assembly language, to verify these assembly-language
litmus tests, and checking compatibility of the outcomes.

Note that the conversion does not yet handle locking, RCU, SRCU, plain
C-language memory accesses, or casts.

Signed-off-by: Paul E. McKenney <paulmck@linux.ibm.com>
---
 tools/memory-model/scripts/checkghlitmus.sh |  9 ++++---
 tools/memory-model/scripts/hwfnseg.sh       | 20 +++++++++++++++
 tools/memory-model/scripts/runlitmushist.sh | 27 +++++++++++++--------
 3 files changed, 42 insertions(+), 14 deletions(-)
 create mode 100755 tools/memory-model/scripts/hwfnseg.sh

diff --git a/tools/memory-model/scripts/checkghlitmus.sh b/tools/memory-model/scripts/checkghlitmus.sh
index 6589fbb6f653..2ea220d2564b 100755
--- a/tools/memory-model/scripts/checkghlitmus.sh
+++ b/tools/memory-model/scripts/checkghlitmus.sh
@@ -10,6 +10,7 @@
 # parseargs.sh scripts for arguments.
 
 . scripts/parseargs.sh
+. scripts/hwfnseg.sh
 
 T=/tmp/checkghlitmus.sh.$$
 trap 'rm -rf $T' 0
@@ -32,9 +33,9 @@ then
 	( cd "$LKMM_DESTDIR"; sed -e 's/^/mkdir -p /' | sh )
 fi
 
-# Create a list of the C-language litmus tests previously run.
-( cd $LKMM_DESTDIR; find litmus -name '*.litmus.out' -print ) |
-	sed -e 's/\.out$//' |
+# Create a list of the specified litmus tests previously run.
+( cd $LKMM_DESTDIR; find litmus -name "*.litmus${hwfnseg}.out" -print ) |
+	sed -e "s/${hwfnseg}"'\.out$//' |
 	xargs -r egrep -l '^ \* Result: (Never|Sometimes|Always|DEADLOCK)' |
 	xargs -r grep -L "^P${LKMM_PROCS}"> $T/list-C-already
 
@@ -44,7 +45,7 @@ find litmus -name '*.litmus' -exec grep -l -m 1 "^C " {} \; > $T/list-C
 xargs < $T/list-C -r egrep -l '^ \* Result: (Never|Sometimes|Always|DEADLOCK)' > $T/list-C-result
 xargs < $T/list-C-result -r grep -L "^P${LKMM_PROCS}" > $T/list-C-result-short
 
-# Form list of tests without corresponding .litmus.out files
+# Form list of tests without corresponding .out files
 sort $T/list-C-already $T/list-C-result-short | uniq -u > $T/list-C-needed
 
 # Run any needed tests.
diff --git a/tools/memory-model/scripts/hwfnseg.sh b/tools/memory-model/scripts/hwfnseg.sh
new file mode 100755
index 000000000000..580c3281181c
--- /dev/null
+++ b/tools/memory-model/scripts/hwfnseg.sh
@@ -0,0 +1,20 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0+
+#
+# Generate the hardware extension to the litmus-test filename, or the
+# empty string if this is an LKMM run.  The extension is placed in
+# the shell variable hwfnseg.
+#
+# Usage:
+#	. hwfnseg.sh
+#
+# Copyright IBM Corporation, 2019
+#
+# Author: Paul E. McKenney <paulmck@linux.ibm.com>
+
+if test -z "$LKMM_HW_MAP_FILE"
+then
+	hwfnseg=
+else
+	hwfnseg=".$LKMM_HW_MAP_FILE"
+fi
diff --git a/tools/memory-model/scripts/runlitmushist.sh b/tools/memory-model/scripts/runlitmushist.sh
index 852786fef179..c6c2bdc67a50 100755
--- a/tools/memory-model/scripts/runlitmushist.sh
+++ b/tools/memory-model/scripts/runlitmushist.sh
@@ -15,6 +15,8 @@
 #
 # Author: Paul E. McKenney <paulmck@linux.ibm.com>
 
+. scripts/hwfnseg.sh
+
 T=/tmp/runlitmushist.sh.$$
 trap 'rm -rf $T' 0
 mkdir $T
@@ -30,15 +32,12 @@ fi
 # Prefixes for per-CPU scripts
 for ((i=0;i<$LKMM_JOBS;i++))
 do
-	echo dir="$LKMM_DESTDIR" > $T/$i.sh
 	echo T=$T >> $T/$i.sh
-	echo herdoptions=\"$LKMM_HERD_OPTIONS\" >> $T/$i.sh
 	cat << '___EOF___' >> $T/$i.sh
 	runtest () {
-		echo ' ... ' /usr/bin/time $LKMM_TIMEOUT_CMD herd7 $herdoptions $1 '>' $dir/$1.out '2>&1'
-		if /usr/bin/time $LKMM_TIMEOUT_CMD herd7 $herdoptions $1 > $dir/$1.out 2>&1
+		if scripts/runlitmus.sh $1
 		then
-			if ! grep -q '^Observation ' $dir/$1.out
+			if ! grep -q '^Observation ' $LKMM_DESTDIR/$1$2.out
 			then
 				echo ' !!! Herd failed, no Observation:' $1
 			fi
@@ -47,10 +46,16 @@ do
 			if test "$exitcode" -eq 124
 			then
 				exitmsg="timed out"
+			elif test "$exitcode" -eq 253
+			then
+				exitmsg=
 			else
 				exitmsg="failed, exit code $exitcode"
 			fi
-			echo ' !!! Herd' ${exitmsg}: $1
+			if test -n "$exitmsg"
+			then
+				echo ' !!! Herd' ${exitmsg}: $1
+			fi
 		fi
 	}
 ___EOF___
@@ -59,11 +64,13 @@ done
 awk -v q="'" -v b='\\' '
 {
 	print "echo `grep " q "^P[0-9]" b "+(" q " " $0 " | tail -1 | sed -e " q "s/^P" b "([0-9]" b "+" b ")(.*$/" b "1/" q "` " $0
-}' | bash |
-sort -k1n |
-awk -v ncpu=$LKMM_JOBS -v t=$T '
+}' | sh | sort -k1n |
+awk -v dq='"' -v hwfnseg="$hwfnseg" -v ncpu="$LKMM_JOBS" -v t="$T" '
 {
-	print "runtest " $2 >> t "/" NR % ncpu ".sh";
+	print "if test -z " dq hwfnseg dq " || scripts/simpletest.sh " dq $2 dq
+	print "then"
+	print "\techo runtest " dq $2 dq " " hwfnseg " >> " t "/" NR % ncpu ".sh";
+	print "fi"
 }
 
 END {
-- 
2.17.1


  parent reply	other threads:[~2019-08-01 22:21 UTC|newest]

Thread overview: 38+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-08-01 22:20 [PATCH RFC memory-model 0/31] LKMM updates for review Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 01/31] tools/memory-model: Make scripts be executable Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 02/31] tools/memory-model: Make judgelitmus.sh note timeouts Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 03/31] tools/memory-model: Make cmplitmushist.sh " Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 04/31] tools/memory-model: Make judgelitmus.sh identify bad macros Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 05/31] tools/memory-model: Make judgelitmus.sh detect hard deadlocks Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 06/31] tools/memory-model: Fix paulmck email address on pre-existing scripts Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 07/31] tools/memory-model: Update parseargs.sh for hardware verification Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 08/31] tools/memory-model: Make judgelitmus.sh handle hardware verifications Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 09/31] tools/memory-model: Add simpletest.sh to check locking, RCU, and SRCU Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 10/31] tools/memory-model: Fix checkalllitmus.sh comment Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 11/31] tools/memory-model: Hardware checking for check{,all}litmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 12/31] tools/memory-model: Make judgelitmus.sh ransack .litmus.out files Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 13/31] tools/memory-model: Split runlitmus.sh out of checklitmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 14/31] tools/memory-model: Make runlitmus.sh generate .litmus.out for --hw Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 15/31] tools/memory-model: Move from .AArch64.litmus.out to .litmus.AArch.out Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 16/31] tools/memory-model: Keep assembly-language litmus tests Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 17/31] tools/memory-model: Allow herd to deduce CPU type Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 18/31] tools/memory-model: Make runlitmus.sh check for jingle errors Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 19/31] tools/memory-model: Add -v flag to jingle7 runs Paul E. McKenney
2019-08-01 22:20 ` Paul E. McKenney [this message]
2019-08-01 22:20 ` [PATCH RFC memory-model 21/31] tools/memory-model: Fix scripting --jobs argument Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 22/31] tools/memory-model: Make checkghlitmus.sh use mselect7 Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 23/31] tools/memory-model: Make history-check scripts " Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 24/31] tools/memory-model: Add "--" to parseargs.sh for additional arguments Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 25/31] tools/memory-model: Repair parseargs.sh header comment Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 26/31] tools/memory-model: Add checktheselitmus.sh to run specified litmus tests Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 27/31] tools/memory-model: Add data-race capabilities to judgelitmus.sh Paul E. McKenney
2019-08-12 14:32   ` Akira Yokosawa
2019-08-12 18:06     ` Paul E. McKenney
2019-08-14 15:11       ` [PATCH 0/2] tools/memory-model: Update comment of jugdelitmus.sh Akira Yokosawa
2019-08-14 15:13         ` Subject: [PATCH 1/2] tools/memory-model: Reflect updated file name convention in judgelitmus.sh Akira Yokosawa
2019-08-14 15:16         ` [PATCH 2/2] tools/memory-model: Mention data-race capability in jugdelitmus.sh's header Akira Yokosawa
2019-08-14 23:24         ` [PATCH 0/2] tools/memory-model: Update comment of jugdelitmus.sh Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 28/31] tools/memory-model: Make judgelitmus.sh handle scripted Result: tag Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 29/31] tools/memory-model: Use "-unroll 0" to keep --hw runs finite Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 30/31] tools/memory-model: Use cumul-fence instead of fence in ->prop example Paul E. McKenney
2019-08-01 22:20 ` [PATCH RFC memory-model 31/31] tools/memory-model: Update the informal documentation Paul E. McKenney

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190801222056.12144-20-paulmck@linux.ibm.com \
    --to=paulmck@linux.ibm.com \
    --cc=akiyks@gmail.com \
    --cc=andrea.parri@amarulasolutions.com \
    --cc=boqun.feng@gmail.com \
    --cc=dhowells@redhat.com \
    --cc=j.alglave@ucl.ac.uk \
    --cc=linux-arch@vger.kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=luc.maranget@inria.fr \
    --cc=mingo@kernel.org \
    --cc=npiggin@gmail.com \
    --cc=peterz@infradead.org \
    --cc=stern@rowland.harvard.edu \
    --cc=will@kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).